function Y = fftshift2D( X )
% shifting quarters of 2D DFT spectrum, for example of an image

[M N] = size(X);
M2 = floor(M/2); Mr = rem(M,2); 
N2 = floor(N/2); Nr = rem(N,2);

Y( M2+1:M, N2+1:N ) = X( 1:M2+Mr,   1:N2+Nr   );
Y( 1:M2,   1:N2   ) = X( M2+1+Mr:M, N2+1+Nr:N );
Y( M2+1:M, 1:N2   ) = X( 1:M2+Mr,   N2+1+Nr:N );    
Y( 1:M2,   N2+1:N ) = X( M2+1+Mr:M, 1:N2+Nr   );
